## palo 2.22

=== ipl/Makefile ===
CFILES=\
	byteio.c      elf64.c	    ipl.c	  offset.c      gzip.c \
	diskpart.c    ext2.c	    lib.c	  pdc_bootio.c  vsprintf.c \
	elf32.c	      fileio.c	    load.c	  pdc_cons.c	pdc_misc.c

OFILES=$(CFILES:.c=.o)

INCLUDES=bootloader.h common.h load.h

# cc-cross-prefix
# Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
# Return first prefix where a prefix$(CC) is found in PATH.
# If no $(CC) found in PATH with listed prefixes return nothing
cc-cross-prefix =  \
	$(word 1, $(foreach c,$(1),                                   \
		$(shell set -e;                                       \
		if (which $(strip $(c))gcc) > /dev/null 2>&1 ; then   \
			echo $(c);                                    \
		fi)))

# cross compilation
CC_ARCHES = hppa hppa1.1
CC_SUFFIXES = linux linux-gnu unknown-linux-gnu
CROSS_COMPILE := $(call cc-cross-prefix, \
	$(foreach a,$(CC_ARCHES), \
	$(foreach s,$(CC_SUFFIXES),$(a)-$(s)-)))

CC	= ${CROSS_COMPILE}gcc
AR	= ar
LD	= ${CROSS_COMPILE}ld
OBJDUMP = ${CROSS_COMPILE}objdump

ifneq ("$(wildcard /etc/debian_version)","")
BLDINFO := $(shell echo https://parisc.wiki.kernel.org - `dpkg-parsechangelog -l../debian/changelog -SDate`)
else
BLDINFO := $(shell echo https://parisc.wiki.kernel.org - `LC_TIME=C date`)
endif

# Source sharing with palo
VPATH=../lib:.

AFLAGS	= -I../lib
CFLAGS	= -DIPL_LOADER -I. -I../lib -I../include -O2 -mdisable-fpregs -Wall -fno-delete-null-pointer-checks -fno-builtin -mpa-risc-1-0
LDFLAGS  = -N --section-start .init=0x60000 -e '$$START$$'

all:	iplelf

iplelf:	crt0.o ipl.a
	echo "const char bld_info[] = \"$(BLDINFO)\";" > build.c
	$(CC) $(CFLAGS) -c -o build.o build.c
	-rm -f build.c
	$(LD) $(LDFLAGS) -o iplelf crt0.o ipl.a build.o `$(CC) -print-libgcc-file-name`
	$(OBJDUMP) -t iplelf | grep -E '__udivdi3|__umoddi3|__muldi3' && (echo "ERROR: Can not use __udivdi3 or __umoddi3 in palo ipl code" && false) || true

ipl.a:	$(OFILES)
	$(AR) rv ipl.a $?

clean:
	rm -f iplelf *.o *.a

distclean: clean


.S.o:
	$(CC) -D__ASSEMBLY__ $(AFLAGS) -traditional -c -o $*.o $<

byteio.o \
ext2.o \
fileio.o \
lib.o \
offset.o \
pdc_bootio.o \
pdc_cons.o \
vsprintf.o :		bootloader.h

ipl.o :		bootloader.h load.h

diskpart.o :		common.h

elf32.o \
elf64.o \
load.o \
som.o :		common.h load.h

=== debian/changelog ===
palo (2.22) unstable; urgency=medium

  [ Helge Deller ]
  * ipl: Add trailing "/" when listing directories
  * diskpart: Don't assume a Linux partition is an ext2 fs
  * ext2: Make error message human readable
  * ipl/palo: Fix partition detection
  * palo: Add palo version in header
  * ipl/ext2: Fix block calculation and close file handle
  * ipl: Close file handles after usage
  * ipl: Add fileio_close() function to close file handles

 -- Helge Deller <deller@gmx.de>  Tue, 09 Aug 2022 08:39:01 +0000

palo (2.21) unstable; urgency=medium

  [ Helge Deller ]
  * ipl: Avoid __udivdi3 and __umoddi3 millicode in palo ipl code
  * ipl: Fix partition detection and printout
  * ipl: Abort early if we know we will not reach the block
  * ipl: Improve error messages and error return code handling

 -- Helge Deller <deller@localhost>  Fri, 05 Aug 2022 21:12:59 +0000

palo (2.20) unstable; urgency=medium

  [ Helge Deller ]
  * ipl: Allow to boot beyond the 2GB disk limit (on most machines)
  * ipl: Allow "list directory" menu entry to show other partitions
  * ipl: Add hex prefix when printing segement load address

 -- Helge Deller <deller@gmx.de>  Thu, 04 Aug 2022 14:39:52 +0000

palo (2.16) unstable; urgency=medium

  [ Helge Deller ]
  * Fix palo to list all entries from the /boot directory

 -- Helge Deller <deller@gmx.de>  Fri, 01 Apr 2022 21:16:22 +0000

=== debian/control ===
Source: palo
Section: admin
Priority: optional
Maintainer: Helge Deller <deller@gmx.de>
Build-Depends: debhelper-compat (= 13), lynx, gcc-hppa-linux-gnu [!hppa], libc6-dev-hppa-cross [!hppa], help2man
Standards-Version: 4.5.0
Homepage: https://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
Vcs-Browser: https://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
Vcs-Git: git://git.kernel.org/pub/scm/linux/kernel/git/deller/palo.git

Package: palo
Architecture: amd64 i386 hppa x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: e2fsprogs
Description: Linux boot loader for HP PA-RISC
 PALO is the boot loader for HP PA-RISC machines. This package contains
 both the actual boot loader called iplboot as well as a boot media
 management tool after which bears the name PALO. While iplboot
 can be used on PA-RISC machines only, the PALO media management tool
 runs on any architecture and is used to create boot media for
 HP PA-RISC machines.

## palo 2.24

=== debian/changelog ===
palo (2.24) unstable; urgency=medium

  [ Helge Deller ]
  * ipl: Fix loading of ramdisk in qemu

 -- Helge Deller <deller@gmx.de>  Tue, 30 May 2023 14:10:51 +0200

palo (2.23) unstable; urgency=medium

  [ Helge Deller ]
  * ipl: Speed up printing the IPL menu on C8000 workstation
  * ipl: Fix argument pointer in real64_call_asm
  * ipl: Enable FPU and remove workarounds

 -- Helge Deller <deller@gmx.de>  Sun, 21 May 2023 08:41:01 +0000

## palo 2.25

=== debian/changelog ===
palo (2.25) unstable; urgency=medium

  [ Helge Deller ]
  * move aliased files from / to /usr (DEP17, Closes: #1061248)

 -- Helge Deller <deller@gmx.de>  Tue, 18 Jun 2024 16:57:10 +0000

## palo 2.27

=== Makefile ===
# Native PARISC/Linux Project Bootstrap Code
#
# Copyright (C) 2000 Hewlett Packard (Paul Bame, bame@puffin.external.hp.com)
# Copyright (C) 1999 Jason Eckhardt <jle@cygnus.com>
#                    Helge Deller <deller@gmx.de>
#                    Christopher Beard <cjbeard@thepuffingroup.com>
#                    Alex deVries <adevries@thepuffingroup.com>
#

# This is here temporarily for folks who still have the old linux makefile
ifneq ($(strip ${TOPDIR}),)
    PA=${TOPDIR}
endif

# here is one which should work for nearly everyone, unless they
# have a different name for their linux tree:
ifeq ($(strip ${PA}),)
    PA := $(shell pwd)/../linux
endif

export PA

# GNU make is needed, can be overridden by environment, e.g. for HP-UX
MAKE ?= make

# Choose at most one of RAMDISK or NFSROOT below
#
# Set RAMDISK to a ramdisk image to in order to load the ramdisk on the
# boot medium and make the default kernel command line to use it
#
# RAMDISK = ${PA}/ramdisk.bin

#
# Set NFSROOT to the IP address of your NFS root server to make
# a kernel command line to use NFS root.  This is incompatible with
# RAMDISK above.  Though you can have both a ramdisk and an NFS root,
# as far as palo is concerned anyway, this Makefile doesn't help you
# do that and I'm not sure the kernel's very good at it right now either.
#
NFSROOT = 10.10.10.2
# NFSROOT = 10.10.10.2:/tftpboot/nfsroot


ROOT=root=/dev/sda1

#
# In case you want to use ISA cards (or any edge triggered EISA cards) in your 
# EISA slots, just uncomment the following line and specify the corresponding 
# irq level(s)
#
# EISAIRQ = eisa_irq_edge=3,4,5,7,9,10,11,14,15


ifneq ($(strip ${RAMDISK}),)
    PALOSTUFF=-r ${RAMDISK}
    ROOT=root=/dev/ram initrd=0/ramdisk
endif

ifneq ($(strip ${NFSROOT}),)
    PALOSTUFF=
    ROOT=root=/dev/nfs nfsroot=${NFSROOT} ip=bootp
endif

CMDLINE = 0/vmlinux HOME=/ TERM=linux $(ROOT) $(EISAIRQ) $(CONSOLE)

HELP2MAN := $(shell command -v help2man 2> /dev/null)

all: makepalo README palo.conf

README:	README.html
	lynx -dump README.html > README

makepalo:
	cd palo && $(MAKE)

makeipl:
	cd ipl && $(MAKE)

lifimage:	all Makefile lifimage-only

lifimage-only: ${PA}/vmlinux iplboot
	./palo/palo -f /dev/null \
		-b iplboot \
		-k ${PA}/vmlinux \
		${PALOSTUFF} \
		-c "${CMDLINE}" \
		-s lifimage

iplboot:	makeipl makepalo ipl/iplelf
	./palo/mkbootable ipl/iplelf iplboot

clean:
	# We intentionally don't remove iplboot here so that the file
	# is available for cross-installation.
	rm -f lifimage palo.8.gz changelog.gz palo.tgz
	cd ipl && $(MAKE) clean
	cd palo && $(MAKE) clean

realclean:
	rm -f iplboot lifimage palo.8.gz changelog.gz README palo.tgz
	cd ipl && $(MAKE) clean
	cd palo && $(MAKE) clean

distclean:
	rm -f lifimage palo.8.gz changelog.gz README palo.tgz
	cd ipl && $(MAKE) distclean
	cd palo && $(MAKE) distclean

ifdef HELP2MAN
palo.8:		makepalo palo/usage.txt palo.help2man
	help2man --section=8 --no-info \
		--name="boot media management tool for PA-RISC/HPPA." \
		--include=palo.help2man ./palo/palo > palo.8
endif

palo.8.gz:	palo.8
	gzip -9 < palo.8 > palo.8.gz

changelog.gz:	debian/changelog
	gzip -9 < debian/changelog > changelog.gz

INSTALL	=	install
IFLAGS	=	-o root -g root
INSTALL	+=	${IFLAGS}
DESTDIR = ./root

SBINDIR ?= /sbin
CONFDIR ?= /etc
DATADIR ?= /usr/share
DOCDIR  ?= /usr/share/doc
MANDIR  ?= /usr/share/man

install: all README.html palo.conf palo/palo palo.8.gz changelog.gz
	${INSTALL} -d ${DESTDIR}${DOCDIR}/palo \
			${DESTDIR}${CONFDIR} ${DESTDIR}${SBINDIR} \
			${DESTDIR}${DATADIR}/palo \
			${DESTDIR}${MANDIR}/man8
	${INSTALL} -m644 palo.conf ${DESTDIR}${DOCDIR}/palo
	${INSTALL} palo/palo ${DESTDIR}$(SBINDIR)
	@# iplboot isn't natively executable -- don't set mode=x
	${INSTALL} -m644 iplboot ${DESTDIR}${DATADIR}/palo
	${INSTALL} -m644 README.html README changelog.gz \
			${DESTDIR}${DOCDIR}/palo
	${INSTALL} -m644 palo.8.gz ${DESTDIR}${MANDIR}/man8

uninstall: 
	${RM} -rf ${DESTDIR}${DOCDIR}/palo
	${RM} -rf ${DESTDIR}${SBINDIR}/palo
	${RM} -rf ${DESTDIR}${DATADIR}/palo
	${RM} -rf ${DESTDIR}${MANDIR}/man8/palo.8.gz

palo.tgz:
	tar cvfz palo.tgz *

# Build RPM source and binary package
palo.rpm rpm:
	rm -f palo.tgz && $(MAKE) palo.tgz && rpmbuild -ta palo.tgz

=== ipl/Makefile ===
--- 
+++ 
@@ -28,19 +28,18 @@
 CC	= ${CROSS_COMPILE}gcc
 AR	= ar
 LD	= ${CROSS_COMPILE}ld
-OBJDUMP = ${CROSS_COMPILE}objdump
 
 ifneq ("$(wildcard /etc/debian_version)","")
-BLDINFO := $(shell echo https://parisc.wiki.kernel.org - `dpkg-parsechangelog -l../debian/changelog -SDate`)
+BLDINFO := $(shell echo https://parisc.docs.kernel.org - `dpkg-parsechangelog -l../debian/changelog -SDate`)
 else
-BLDINFO := $(shell echo https://parisc.wiki.kernel.org - `LC_TIME=C date`)
+BLDINFO := $(shell echo https://parisc.docs.kernel.org - `LC_TIME=C date`)
 endif
 
 # Source sharing with palo
 VPATH=../lib:.
 
 AFLAGS	= -I../lib
-CFLAGS	= -DIPL_LOADER -I. -I../lib -I../include -O2 -mdisable-fpregs -Wall -fno-delete-null-pointer-checks -fno-builtin -mpa-risc-1-0
+CFLAGS	= -DIPL_LOADER -I. -I../lib -I../include -O2 -mdisable-fpregs -Wall -fno-delete-null-pointer-checks -fno-builtin
 LDFLAGS  = -N --section-start .init=0x60000 -e '$$START$$'
 
 all:	iplelf
@@ -50,7 +49,6 @@
 	$(CC) $(CFLAGS) -c -o build.o build.c
 	-rm -f build.c
 	$(LD) $(LDFLAGS) -o iplelf crt0.o ipl.a build.o `$(CC) -print-libgcc-file-name`
-	$(OBJDUMP) -t iplelf | grep -E '__udivdi3|__umoddi3|__muldi3' && (echo "ERROR: Can not use __udivdi3 or __umoddi3 in palo ipl code" && false) || true
 
 ipl.a:	$(OFILES)
 	$(AR) rv ipl.a $?

=== palo/Makefile ===
CFILES=\
	diskpart.c    elf64.c	    load.c	  paloio.c      \
	elf32.c	      error.c	    gzip.c	  palo.c

OFILES=$(CFILES:.c=.o)


INCLUDES=common.h load.h palo.h

OS := $(shell uname -s)
CC?=cc
ifeq ($(strip ${OS}),HP-UX)
CFLAGS=-g -O -I../include -I../lib -I$(PA)/include
else
CFLAGS=-g -O -I../include -I../lib -D_FILE_OFFSET_BITS=64
endif

ifneq ("$(wildcard /etc/debian_version)","")
BLDINFO := $(shell echo https://parisc.docs.kernel.org - `dpkg-parsechangelog -l../debian/changelog -SDate`)
else
BLDINFO := $(shell echo https://parisc.docs.kernel.org - `LC_TIME=C date`)
endif

# LDFLAGS=-Wl,-Bstatic 
LDFLAGS=

OFILES2=mkbootable.o elf64.o load.o paloio.o elf32.o error.o gzip.o

# Source sharing with ipl
VPATH=../lib:.

all:	palo mkbootable

palo:	palo.a
	echo "const char bld_info[] = \"$(BLDINFO)\";" > build.c
	$(CC) $(CFLAGS) -c -o build.o build.c
	-rm -f build.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o palo palo.a build.o

palo.a:	$(OFILES)
	$(AR) rv palo.a $?

mkbootable:	$(OFILES2)
	$(CC) $(CFLAGS) $(LDFLAGS) -o mkbootable $(OFILES2)

clean:
	rm -f palo mkbootable *.a *.o usage.h

distclean: clean

usage.h:	usage.txt
	sed 's/.*/"&\\n"/' < usage.txt > usage.h

###############}

diskpart.o :		common.h

elf32.o \
elf64.o \
load.o :		common.h load.h

som.o :		common.h load.h

palo.o :		load.h palo.h

paloio.o :		palo.h

error.o:	usage.h error.c

=== debian/changelog ===
palo (2.27) unstable; urgency=medium

  [ Helge Deller ]
  * Fix loading initrd from CD-ROM on C8000 by limiting transfer size
  * ipl: Add hidden option to toggle block read mode

 -- Helge Deller <deller@mx.de>  Tue, 14 Jan 2025 01:05:37 +0000

palo (2.26) unstable; urgency=medium

  [ Helge Deller ]
  * Fix file permissions of documentation (Closes: #1092419)
  * Rephrased 2GB boot limit message in palo ipl loader
  * PA-RISC Wiki was migrated to kerneldoc documentation

  [ Martin Hauke ]
  * Adjust pathnames for openSUSE. Prepare for initial openSUSE package.

 -- Helge Deller <deller@gmx.de>  Tue, 07 Jan 2025 20:40:42 +0000

## palo 2.28

=== Makefile ===
--- 
+++ 
@@ -86,7 +86,7 @@
 		-c "${CMDLINE}" \
 		-s lifimage
 
-iplboot:	makeipl makepalo ipl/iplelf
+iplboot:	makeipl makepalo
 	./palo/mkbootable ipl/iplelf iplboot
 
 clean:

=== ipl/Makefile ===
--- 
+++ 
@@ -40,6 +40,7 @@
 
 AFLAGS	= -I../lib
 CFLAGS	= -DIPL_LOADER -I. -I../lib -I../include -O2 -mdisable-fpregs -Wall -fno-delete-null-pointer-checks -fno-builtin
+CFLAGS	+= -Wno-old-style-definition
 LDFLAGS  = -N --section-start .init=0x60000 -e '$$START$$'
 
 all:	iplelf

=== palo/Makefile ===
--- 
+++ 
@@ -13,6 +13,7 @@
 CFLAGS=-g -O -I../include -I../lib -I$(PA)/include
 else
 CFLAGS=-g -O -I../include -I../lib -D_FILE_OFFSET_BITS=64
+CFLAGS+=-Wno-old-style-definition
 endif
 
 ifneq ("$(wildcard /etc/debian_version)","")

=== debian/changelog ===
palo (2.28) unstable; urgency=medium

  [ Helge Deller ]
  * Fix various build warnings reported by Debian

 -- Helge Deller <deller@gmx.de>  Sat, 06 Sep 2025 10:01:23 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Helge Deller <deller@gmx.de>
-Build-Depends: debhelper-compat (= 13), lynx, gcc-hppa-linux-gnu [!hppa], libc6-dev-hppa-cross [!hppa], help2man
+Build-Depends: debhelper-compat (= 13), lynx, gcc-hppa-linux-gnu [!hppa], libc6-dev-hppa-cross [!hppa], help2man, dh-sequence-movetousr
 Standards-Version: 4.5.0
 Homepage: https://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
 Vcs-Browser: https://git.kernel.org/cgit/linux/kernel/git/deller/palo.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_build:
	echo "Regenerating iplboot."
	$(MAKE) realclean
	$(MAKE) iplboot
	dh_auto_build

%:
	dh $@

## palo 2.29

=== debian/changelog ===
palo (2.29) unstable; urgency=medium

  [ Helge Deller ]
  * psc_misc: Add function to get PDC firmware version
  * ipl: Fix mfg mode on C8000, rp34x0 and rp44x0

 --  Helge Deller <deller@gmx.de>  Sun, 11 Jan 2026 18:02:34 +0000
